给出N个硬币的列表,它们的值(V1,V2,...,VN)和总和S.找到最小数量的硬币,其总和是S(我们可以使用尽可能多的硬币我们想要的一种类型,或者报告说不可能选择硬币,使它们总和为S.
我尝试理解动态编程,但还没弄清楚。我不明白给出的解释,所以也许你可以给我一些提示如何编程这个任务?没有代码,只是我应该开始的想法。
感谢。
答案 0 :(得分:11)
这里很好地解释了这个问题的确切答案。 http://www.topcoder.com/tc?module=Static&d1=tutorials&d2=dynProg
答案 1 :(得分:6)
这是一个经典的背包问题,请点击此处查看更多信息:Wikipedia Knapsack Problem
您还应该查看一些排序,特别是从最大值到最小值的排序。
答案 2 :(得分:3)
正如已经指出的那样,动态编程最适合这个问题。我为此编写了一个Python程序: -
def sumtototal(total, coins_list):
s = [0]
for i in range(1, total+1):
s.append(-1)
for coin_val in coins_list:
if i-coin_val >=0 and s[i-coin_val] != -1 and (s[i] > s[i-coin_val] or s[i] == -1):
s[i] = 1 + s[i-coin_val]
print s
return s[total]
total = input()
coins_list = map(int, raw_input().split(' '))
print sumtototal(total, coins_list)
输入:
12
2 3 5
输出结果为:
[0, -1, 1, 1, 2, 1, 2, 2, 2, 3, 2, 3, 3]
3
list_index是所需的总数,list_index的值是no。获得总数所需的硬币上面输入(得到值12)的答案是3(值为5,5,2的硬币)。
答案 3 :(得分:2)
我认为你想要的方法是这样的:
你知道你想要产生一笔金额S
。制作S
的唯一方法是先生成S-V1
,然后添加一个价值为V1
的硬币;或者生成S-V2
然后添加一个价值为V2
的硬币;或...
反过来,T=S-V1
可以从T-V1
或T-V2
生成,或者......
通过这种方式退回,您可以确定从S
生成V
的最佳方式(如果有)。
答案 4 :(得分:1)
问题已经回答,但我想提供我编写的工作C代码,如果它可以帮助任何人。 enter code here
代码具有硬编码输入,但它只是为了保持简单。最终解决方案是包含每个总和所需硬币数量的数组min。
#include"stdio.h"
#include<string.h>
int min[12] = {100};
int coin[3] = {1, 3, 5};
void
findMin (int sum)
{
int i = 0; int j=0;
min [0] = 0;
for (i = 1; i <= sum; i++) {
/* Find solution for Sum = 0..Sum = Sum -1, Sum, i represents sum
* at each stage */
for (j=0; j<= 2; j++) {
/* Go over each coin that is lesser than the sum at this stage
* i.e. sum = i */
if (coin[j] <= i) {
if ((1 + min[(i - coin[j])]) <= min[i]) {
/* E.g. if coin has value 2, then for sum i = 5, we are
* looking at min[3] */
min[i] = 1 + min[(i-coin[j])];
printf("\nsetting min[%d] %d",i, min[i]);
}
}
}
}
}
void
initializeMin()
{
int i =0;
for (i=0; i< 12; i++) {
min[i] = 100;
}
}
void
dumpMin()
{
int i =0;
for (i=0; i< 12; i++) {
printf("\n Min[%d]: %d", i, min[i]);
}
}
int main()
{
initializeMin();
findMin(11);
dumpMin();
}
答案 5 :(得分:0)
我不知道动态编程,但我就是这样做的。从零开始,一路前往S
。使用一个硬币生成一个集合,然后使用该集合生成两个硬币集,依此类推......搜索S
,并忽略大于S
的所有值。对于每个值,记住使用的硬币数量。
答案 6 :(得分:0)
很多人已经回答了这个问题。这是一个使用DP的代码
public static List<Integer> getCoinSet(int S, int[] coins) {
List<Integer> coinsSet = new LinkedList<Integer>();
if (S <= 0) return coinsSet;
int[] coinSumArr = buildCoinstArr(S, coins);
if (coinSumArr[S] < 0) throw new RuntimeException("Not possible to get given sum: " + S);
int i = S;
while (i > 0) {
int coin = coins[coinSumArr[i]];
coinsSet.add(coin);
i -= coin;
}
return coinsSet;
}
public static int[] buildCoinstArr(int S, int[] coins) {
Arrays.sort(coins);
int[] result = new int[S + 1];
for (int s = 1; s <= S; s++) {
result[s] = -1;
for (int i = coins.length - 1; i >= 0; i--) {
int coin = coins[i];
if (coin <= s && result[s - coin] >= 0) {
result[s] = i;
break;
}
}
}
return result;
}
答案 7 :(得分:0)
主要思想是 - 对于每个硬币j,值[j]&lt; = i(即总和)我们查看为i值[j](比如说m)求和找到的最小硬币数量(之前找到的) )。如果m + 1小于当前总和i已经找到的最小硬币数,那么我们更新阵列中的硬币数量。
对于ex - sum = 11 n = 3且值[] = {1,3,5}
以下是我们获得的输出
i- 1 mins[i] - 1
i- 2 mins[i] - 2
i- 3 mins[i] - 3
i- 3 mins[i] - 1
i- 4 mins[i] - 2
i- 5 mins[i] - 3
i- 5 mins[i] - 1
i- 6 mins[i] - 2
i- 7 mins[i] - 3
i- 8 mins[i] - 4
i- 8 mins[i] - 2
i- 9 mins[i] - 3
i- 10 mins[i] - 4
i- 10 mins[i] - 2
i- 11 mins[i] - 3
正如我们可以观察到的总和i = 3,5,8和10,我们通过以下方式改进了之前的最小值 -
sum = 3, 3 (1+1+1) coins of 1 to one 3 value coin
sum = 5, 3 (3+1+1) coins to one 5 value coin
sum = 8, 4 (5+1+1+1) coins to 2 (5+3) coins
sum = 10, 4 (5+3+1+1) coins to 2 (5+5) coins.
因此,对于sum = 11,我们将得到3(5 + 5 + 1)的答案。
这是C中的代码。它类似于topcoder页面中给出的伪代码,其参考在上面的一个答案中提供。
int findDPMinCoins(int value[], int num, int sum)
{
int mins[sum+1];
int i,j;
for(i=1;i<=sum;i++)
mins[i] = INT_MAX;
mins[0] = 0;
for(i=1;i<=sum;i++)
{
for(j=0;j<num;j++)
{
if(value[j]<=i && ((mins[i-value[j]]+1) < mins[i]))
{
mins[i] = mins[i-value[j]] + 1;
printf("i- %d mins[i] - %d\n",i,mins[i]);
}
}
}
return mins[sum];
}
答案 8 :(得分:0)
int getMinCoins(int arr[],int sum,int index){
int INFINITY=1000000;
if(sum==0) return 0;
else if(sum!=0 && index<0) return INFINITY;
if(arr[index]>sum) return getMinCoins(arr, sum, index-1);
return Math.min(getMinCoins(arr, sum, index-1), getMinCoins(arr, sum-arr[index], index-1)+1);
}
考虑我的硬币。它是否包括在内。如果包含它,则值总和减少硬币值,并且使用的硬币数量增加1.如果不包括,那么我们需要类似地探索剩余的硬币。我们至少接受两个案例。
答案 9 :(得分:0)
我知道这是一个老问题,但这是Java的解决方案。
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
public class MinCoinChange {
public static void min(int[] coins, int money) {
int[] dp = new int[money + 1];
int[] parents = new int[money + 1];
int[] usedCoin = new int[money + 1];
Arrays.sort(coins);
Arrays.fill(dp, Integer.MAX_VALUE);
Arrays.fill(parents, -1);
dp[0] = 0;
for (int i = 1; i <= money; ++i) {
for (int j = 0; j < coins.length && i >= coins[j]; ++j) {
if (dp[i - coins[j]] + 1 < dp[i]) {
dp[i] = Math.min(dp[i], dp[i - coins[j]] + 1);
parents[i] = i - coins[j];
usedCoin[i] = coins[j];
}
}
}
int parent = money;
Map<Integer, Integer> result = new HashMap<>();
while (parent != 0) {
result.put(usedCoin[parent], result.getOrDefault(usedCoin[parent], 0) + 1);
parent = parents[parent];
}
System.out.println(result);
}
public static void main(String[] args) {
int[] coins = { 1, 5, 10, 25 };
min(coins, 30);
}
}
答案 10 :(得分:0)
对于快速递归解决方案,您可以检查以下链接:java solution
我正在按照最小的步骤来寻找完美的硬币组合。
假设我们有coins = [20, 15, 7]
和monetaryValue = 37
。我的解决方案如下:
[20] -> sum of array bigger than 37? NO -> add it to itself
[20, 20] greater than 37? YES (20 + 20) -> remove last and jump to smaller coin
[20, 15] 35 OK
[20, 15, 15] 50 NO
[20, 15, 7] 42 NO
// Replace biggest number and repeat
[15] 15 OK
[15, 15] 30 OK
[15, 15, 15] 45 NO
[15, 15, 7] 37! RETURN NUMBER!
答案 11 :(得分:0)
def leastCoins(lst, x):
temp = []
if x == 0:
return 0
else:
while x != 0:
if len(lst) == 0:
return "Not Possible"
if x % max(lst) == 0:
temp.append((max(lst), x//max(lst)))
x = 0
elif max(lst) < x:
temp.append((max(lst), x//max(lst)))
x = x % max(lst)
lst.remove(max(lst))
else:
lst.remove(max(lst))
return dict(temp)
leastCoins([17,18,2],100652895656565)